;
; RCPL.LSP:REGISTO COORDENADAS EM FICHEIRO DE TEXTO


(defun c:RCPL (/ SGPOLY NUMOBJ NAMENT ENTGT TIPENT)
(command "undo" "begin")
(setvar "DIMZIN" 0)
(setvar "cmdecho" 0)
(princ "Seleccione pline")  
(setq SGPOLY (ssget))
(if SGPOLY (progn
(setq NUMOBJ (sslength SGPOLY))
(if (= NUMOBJ 1)(progn
(setq NAMENT (ssname SGPOLY (1- NUMOBJ)))
(setq ENTGT (entget NAMENT))
(setq TIPENT (cdr (assoc 0 ENTGT)))
(if (equal TIPENT "LWPOLYLINE")
(DFLWPOLY)
)
(if (equal TIPENT "POLYLINE")
(DFPOLY)
)
)
(princ " Seleccione apenas uma pline...  ")
)
)
(princ " Nenhuma entidade seleccionada...  ")
)
(setvar "DIMZIN" DZIN)
(command "undo" "end")
)
(terpri)
(princ "  Inicie aplicao digitando RCPL  ")
(terpri)

;
;
;

(defun DFLWPOLY (/ VALLPRC UNPRC VIRG NMFILE FILETX SSLEN TEMP ENPOLY SSLENP
		   VALPOLY FIRSTEL PTZVERT TXCORDZ PTXVERT PTYVERT TXCORDX TXCORDY)

(setq DZIN (getvar "DIMZIN"))
(setq VALLPRC (getvar "luprec"))
(princ " Quantas casas decimais? (0/8) ")(princ "<") (princ VALLPRC)(princ ">")
(terpri)
(setq UNPRC (getint))
(if (= UNPRC nil) (setq UNPRC VALLPRC))
(terpri)
(setq VIRG ",")
(setq NMFILE (getfiled "Ficheiro para registo das coordenadas" "" "txt" 1))
(setq FILETX (open NMFILE "a"))
(setq SSLEN (sslength SGPOLY))
(while (> SSLEN 0)
(setq TEMP (ssname SGPOLY (setq SSLEN (1- SSLEN))))   
(setq ENPOLY (entget TEMP))
(setq SSLENP (length ENPOLY))
(while (> SSLENP 0)
(setq SSLENP (1- SSLENP))      
(setq VALPOLY (nth SSLENP ENPOLY))
(setq FIRSTEL (car VALPOLY))
(setq PTZVERT (cdr (assoc 38 ENPOLY)))
(setq TXCORDZ (rtos PTZVERT 2 UNPRC))
(if (= FIRSTEL 10)(progn
(setq PTXVERT (nth 1 VALPOLY))
(setq PTYVERT (nth 2 VALPOLY))
(setq TXCORDX (rtos PTXVERT 2 UNPRC))
(setq TXCORDY (rtos PTYVERT 2 UNPRC))
(write-line (strcat ""TXCORDX""VIRG""TXCORDY""VIRG""TXCORDZ"") FILETX)
)
)
)
(close FILETX)
)
(setvar "DIMZIN" DZIN)
)

;
;
;

(defun DFPOLY (/ VALLPRC UNPRC VIRG NMFILE FILETX SSLEN TEMPA ENPOLYA VERT TESSPL ENVERTA SSLENPA 
	         VALVERA FIRSTEL PTXVERT PTYVERT PTZVERT TXCORDX TXCORDY TXCORDZ TESTVER)

(setq DZIN (getvar "DIMZIN"))	      
(setq VALLPRC (getvar "luprec"))
(princ " Quantas casas decimais? (0/8) ")(princ "<") (princ VALLPRC)(princ ">")
(terpri)
(setq UNPRC (getint))
(if (= UNPRC nil) (setq UNPRC VALLPRC))
(terpri)
(setq VIRG ",")
(setq NMFILE (getfiled "Ficheiro para registo das coordenadas" "" "txt" 1))
(setq FILETX (open NMFILE "a"))
(setq SSLEN (sslength SGPOLY))
(setq TEMPA (ssname SGPOLY (setq SSLEN (1- SSLEN))))   
(setq ENPOLYA (entget TEMPA))
(setq VERT (entnext TEMPA))
(setq TESSPL (cdr (assoc 70 ENPOLYA)))
(if (or (= TESSPL 4) (= TESSPL 5) (= TESSPL 8) (= TESSPL 12)) (progn
(setq TEMPA VERT)
(setq VERT (entnext TEMPA))
)
)
(while VERT
(setq ENVERTA (entget VERT))
(setq SSLENPA (length ENVERTA))
(while (> SSLENPA 0)
(setq SSLENPA (1- SSLENPA))      
(setq VALVERA (nth SSLENPA ENVERTA))
(setq FIRSTEL (car VALVERA))
(if (= FIRSTEL 10)(progn
(setq PTXVERT (nth 1 VALVERA))
(setq PTYVERT (nth 2 VALVERA))
(setq PTZVERT (nth 3 VALVERA))	  
(setq TXCORDX (rtos PTXVERT 2 UNPRC))
(setq TXCORDY (rtos PTYVERT 2 UNPRC))
(setq TXCORDZ (rtos PTZVERT 2 UNPRC))	  
(write-line (strcat ""TXCORDX""VIRG""TXCORDY""VIRG""TXCORDZ"") FILETX)
)
)
)
(setq TEMPA VERT)
(setq VERT (entnext TEMPA))
(setq TESTVER (cdr (assoc 0 ENVERTA)))
(if (/= TESTVER "VERTEX")
(setq VERT nil)
)
)
(close FILETX)
) 
