;File name: TEXTOUT.LSP: 
;(Note: if you select text to be exported by a window or crossing window,
;the last line of text in the drawing database will be exported first. 
;To insure an exported file that matches the drawing text, select 
;individual lines of text, rather than windowing.)

(defun export() 
  (setq lines (ssget)) 
  (prompt (strcat "\nWriting file " (strcase testfil) " -- One moment...\n")) 
  (setq fname (open testfil "w")) 
  (setq total (sslength lines) 
        test 0) 
  (while (< test total) 
      (prin1 '-) 
      (setq alist (entget (ssname lines test))) 
      (if 
          (= "TEXT" (cdr (assoc 0 alist))) 
          (progn 
             (setq TEXTV (cdr (assoc 1 alist)))
             (setq TEXTX (rtos (car (cdr (assoc 10 alist))) 2 2))
             (setq TEXTY (rtos (cadr (cdr (assoc 10 alist))) 2 2))
             (write-line (strcat TEXTV "     " TEXTX "     " TEXTY) fname) 
          )
      ) 
      (setq test (1+ test)) 
   ) ; End of WHILE function 
   (close fname) 
   (prompt (strcat "\nFile " (strcase testfil) " written.\n")) 

) 

(defun oldfile() 
  (close fname) 

  (setq yn 
     (getstring "File already exists. Do you want to overwrite it? <N> ") 
  ) 
    (if (or (= yn "") (= (strcase yn) "N")) 
        (setq go nil) 
        (setq go 1) 
    ) 

)

(defun C:TEXTOUT() 
   (setq oldech (getvar "CMDECHO")) 
;   (setq oldhlt (getvar "HIGHLIGHT")) 
   (setvar "CMDECHO" 0) 
;   (setvar "HIGHLIGHT" 0) 

       (setq go 1) 

       (setq testfil (getfiled "TEXTOUT - ASCII Filename" "" "txt" 1))
;       (setq testfil (getstring "Name of ASCII file to create: ")) 

       (setq fname (open testfil "r")) 

       (if (/= fname nil) 
           (oldfile) 
       ) 
       (if (/= go nil) 
           (export) 
       ) 
;   (setvar "HIGHLIGHT" oldhlt) 
   (setvar "CMDECHO" oldech) 

) 