;Command: ALIGN
;
(defun rtd(a)(* (/ a pi) 180.0))

(defun C:ALIGN ( / a b c d ab au ad objects ans scl rota)

   (setq ab (getvar "ANGBASE")
         au (getvar "AUNITS")
			ad (getvar "ANGDIR")
	);setq

   (setvar "ANGBASE" 0)
   (setvar "AUNITS" 0)
	(setvar "ANGDIR" 0)

   ; get the objects to align
   (setq objects (ssget))

   ; get the alignment points
	(setq a (getpoint "\nSelect first source point: "))
	
   (setq b (getpoint a "\nSelect first destination point: "))
	
	(setq c (getpoint "\nSelect second source point: 3rd"))
	
	(setq	d (getpoint c "\nSelect second destination point: 4th"))

   (initget "Y y N n")
	(setq ans (getkword "\nScale objects based on alignment points? [Yes/No] <N>: "))

   (command "MOVE" objects "" a b)
	
	(setq rota (rtd (- (angle b d) (angle a c))))
	(command "ROTATE" objects "" b rota)
	
	(if (= (strcase ans) "Y")
	   (progn
	   (setq scl (/ (distance b d) (distance a c)))
	   (command "SCALE" objects "" b scl)
		);progn
	);if

   (setvar "ANGBASE" ab)
   (setvar "AUNITS" au)
	(setvar "ANGDIR" ad)

	(princ)
)